/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
)

// checks if the CampaignsList type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &CampaignsList{}

// CampaignsList struct for CampaignsList
type CampaignsList struct {
	Results []Campaign `json:"results"`
	Total int32 `json:"total"`
}

// NewCampaignsList instantiates a new CampaignsList object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewCampaignsList(results []Campaign, total int32) *CampaignsList {
	this := CampaignsList{}
	this.Results = results
	this.Total = total
	return &this
}

// NewCampaignsListWithDefaults instantiates a new CampaignsList object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewCampaignsListWithDefaults() *CampaignsList {
	this := CampaignsList{}
	return &this
}

// GetResults returns the Results field value
func (o *CampaignsList) GetResults() []Campaign {
	if o == nil {
		var ret []Campaign
		return ret
	}

	return o.Results
}

// GetResultsOk returns a tuple with the Results field value
// and a boolean to check if the value has been set.
func (o *CampaignsList) GetResultsOk() ([]Campaign, bool) {
	if o == nil {
		return nil, false
	}
	return o.Results, true
}

// SetResults sets field value
func (o *CampaignsList) SetResults(v []Campaign) {
	o.Results = v
}

// GetTotal returns the Total field value
func (o *CampaignsList) GetTotal() int32 {
	if o == nil {
		var ret int32
		return ret
	}

	return o.Total
}

// GetTotalOk returns a tuple with the Total field value
// and a boolean to check if the value has been set.
func (o *CampaignsList) GetTotalOk() (*int32, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Total, true
}

// SetTotal sets field value
func (o *CampaignsList) SetTotal(v int32) {
	o.Total = v
}

func (o CampaignsList) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o CampaignsList) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["results"] = o.Results
	toSerialize["total"] = o.Total
	return toSerialize, nil
}

type NullableCampaignsList struct {
	value *CampaignsList
	isSet bool
}

func (v NullableCampaignsList) Get() *CampaignsList {
	return v.value
}

func (v *NullableCampaignsList) Set(val *CampaignsList) {
	v.value = val
	v.isSet = true
}

func (v NullableCampaignsList) IsSet() bool {
	return v.isSet
}

func (v *NullableCampaignsList) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableCampaignsList(val *CampaignsList) *NullableCampaignsList {
	return &NullableCampaignsList{value: val, isSet: true}
}

func (v NullableCampaignsList) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableCampaignsList) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


